'''
Created on 28/mar/2010
'''
import pygame,things,data_loader,menu,os
from   pygame.locals import*
pygame.mixer.pre_init(44100,16,2,4096)
pygame.init()
pygame.mixer.init()
pygame.key.set_repeat(1,100)
pygame.mouse.set_visible(False)
screen=pygame.display.set_mode((800,600))
class main():
    def __init__(self):
        self.levellist=[[1,30,"pappa.png",["cappello.png","rum1.png","rum2.png","barile1.png","barile2.png","benda.png","canna1.png","canna2.png","palla.png","pistola1.png","pistola2.png","tesoro1.png","tesoro2.png","uncino.png","spada1.png","spada2.png","gamba1.png","gamba2.png"],"pappa.wav",0,15,"pavimento.png",1.1,1.2,2,1.5,-1,2],[1,40,"rum1.png",["cappello.png","pappa.png","barile1.png","barile2.png","benda.png","canna1.png","canna2.png","palla.png","pistola1.png","pistola2.png","tesoro1.png","tesoro2.png","uncino.png","spada1.png","spada2.png","gamba1.png","gamba2.png"],"rhum.wav",0,20,"pavimento.png",1.3,1.4,1,2,4,-2]]
        self.levellist+=[[3,50,"gamba2.png",["pappa.png","cappello.png","rum1.png","rum2.png","barile1.png","barile2.png","benda.png","canna1.png","canna2.png","palla.png","pistola1.png","pistola2.png","tesoro1.png","tesoro2.png","uncino.png","spada1.png","spada2.png"],"leg.wav",0,25,"pavimento.png",1.8,1.5,-2,-3,-4,1.5],[1,60,"uncino.png",["rum1.png","rum2.png","cappello.png","pappa.png","barile1.png","barile2.png","benda.png","canna1.png","canna2.png","palla.png","pistola1.png","pistola2.png","tesoro1.png","tesoro2.png","spada1.png","spada2.png","gamba1.png","gamba2.png"],"hook.wav",0,30,"pavimento.png",2.1,1.9,2,1.5,-1.5,3]]
        self.copy=self.levellist
        self.levellist=[]
        for level in self.copy:
            self.levellist.append(things.level(*level))
        self.currentlevel=0
        self.level=self.levellist[self.currentlevel]
        self.menu=None
        self.screen=screen
        pygame.display.set_caption("Wibbly Waves")
        icon=data_loader.load_image("icon.png",False).convert()
        pygame.display.set_icon(icon)  
        self.clock=pygame.time.Clock()
        self.state="start"
        self.instructions=["Find the capitain's belongings on a messed and wobbling floor.","Don't run out of time!","If you are too late the captain will feed you to the sharks.","Select your choice in the menu with the mouse.","During the game pickup,move and drop objects with the mouse.","To win free your goal from other objects,", "before clicking on it." ,"Press any key to return to menu"]
        place=os.path.join("fonts","old.ttf")
        loadedfont= pygame.font.Font(place,20)
        self.inst_readytext=pygame.Surface((800,600))
        height=0
        n=0
        self.levelup=0
        self.music1=data_loader.load_audio("wave.mp3")
        if self.music1!=0:
            pygame.mixer.music.play(-1)    
        for line in self.instructions:
            height=75*n+25
            n=n+1
            readyline=loadedfont.render(line,0,(255,255,255),(255,255,255))
            readyline.set_colorkey((255,255,255))
            self.inst_readytext.blit(readyline,(25,height))
        self.inst_readytext.set_colorkey((0,0,0))    
        self.good=data_loader.load_sound("good.wav") 
        self.good.set_volume(0.3)
        self.over=data_loader.load_sound("over.wav")
        self.over.set_volume(0.1)
        self.hoho=data_loader.load_sound("hoho.wav") 
        self.hoho.set_volume(0.2)  
        loadedfont= pygame.font.Font(place,100)
        self.key_menu= loadedfont.render("Press any Key",0,(255,0,0),(255,255,255))
        self.key_menu.set_colorkey((255,255,255))
        self.next_level=loadedfont.render("Level Up!",0,(255,0,0),(255,255,255))   
        self.next_level.set_colorkey((255,255,255))
        self.find=loadedfont.render("Find:",0,(255,0,0),(255,255,255))
        self.find.set_colorkey((255,255,255))
        loadedfont= pygame.font.Font(place,55)
        self.captain=loadedfont.render("You'll be captain one day!!!",0,(255,0,0),(255,255,255))   
        self.captain.set_colorkey((255,255,255))
        self.hook=data_loader.load_image("uncino2.png",(255,255,255))
        self.hook_rect=self.hook.get_rect()
        self.start_image=data_loader.load_image("titolo.png",False)
        self.over_image=data_loader.load_image("gamever.png",(255,255,255))
        self.hole_image=data_loader.load_image("pallaver.png",(255,255,255))
        self.level_image=data_loader.load_image("paviover.png",(255,255,255))
        self.choice=menu.menu(800,[["New Game",50,"next level",(255,0,0)],["Instructions",50,"instructions",(255,0,0)]],100,200,50)
    def main_loop(self):
        while True:
            self.clock.tick(70)
            if self.state=="game":
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        pygame.quit()   
                        return  
                    elif event.type == MOUSEBUTTONDOWN:
                        m_x,m_y=pygame.mouse.get_pos()
                        oldsprites=self.level.things.sprites()
                        oldsprites.reverse()
                        for thing in oldsprites:
                            if thing.rect.collidepoint(m_x,m_y):
                                self.level.grabbed.add(thing)
                                self.level.things.remove(thing)
                                sprites=self.level.things.sprites() 
                                sprites.append(thing)                             
                                self.level.things.empty()
                                self.level.things.add(sprites)
                                break
                        if self.level.winner.sprite.rect.collidepoint(m_x,m_y)and pygame.sprite.spritecollide(self.level.winner.sprite,self.level.things,0)==[]:
                            self.state="next level"
                            self.currentlevel+=1
                            if len(self.levellist)>self.currentlevel: 
                                self.level=self.levellist[self.currentlevel]     
                                self.level.timer.going=0
                                self.level.timer.secondsleft=self.level.timer.startseconds+self.level.timer.seconds
                                self.level.timer.minutesleft=self.level.timer.startminutes+self.level.timer.minutes
                                self.levelup=1
                                self.good.play()  
                            else:
                                self.state="victory"       
                    elif event.type == MOUSEBUTTONUP:
                        self.level.grabbed.empty()        
                if self.level.grabbed.sprite!=None:            
                    self.level.grabbed.sprite.x,self.level.grabbed.sprite.y=pygame.mouse.get_pos()  
                    self.level.grabbed.sprite.rect=self.level.grabbed.sprite.image.get_rect(center=(self.level.grabbed.sprite.x,self.level.grabbed.sprite.y))
                self.level.update() 
                if self.level.timer.going==0 and not self.levelup:
                    self.state="game over"                 
                screen.blit(self.level.bgimage,(self.level.bgx,self.level.bgy))       
                self.level.winner.draw(self.screen)
                self.level.things.draw(self.screen)
                self.level.grabbed.draw(self.screen)
                self.screen.blit(self.level.timer.readytext,(0,0))
                m_x,m_y=pygame.mouse.get_pos()
                self.hook_rect=self.hook.get_rect(center=(m_x,m_y))
                self.screen.blit(self.hook,self.hook_rect)
                pygame.display.update()  
            if self.state=="game over":
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        pygame.quit()   
                        return
                    elif event.type == KEYDOWN:
                        self.state="menu"  
                self.screen.blit(self.level_image,(0,0))
                self.screen.blit(self.over_image,(50,200))
                self.screen.blit(self.hole_image,(370,150))   
                self.screen.blit(self.key_menu,(50,470))
                pygame.display.update()         
                self.over.play()        
                self.level.timer.clock.tick() 
            if self.state=="instructions":
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        pygame.quit()   
                        return 
                    elif event.type == KEYDOWN:
                        self.state="menu"      
                self.screen.blit(self.level_image,(0,0))        
                self.screen.blit(self.inst_readytext,(0,0))
                self.level.timer.clock.tick() 
                pygame.display.update()           
            if self.state=="next level":
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        pygame.quit()   
                        return
                    elif event.type == KEYDOWN:
                        self.state="game"  
                        self.level.timer.going=1
                        self.levelup=0
                self.screen.blit(self.level_image,(0,0))   
                if self.currentlevel!=0:            
                    self.screen.blit(self.next_level,(100,200))
                self.screen.blit(self.key_menu,(25,300))
                self.screen.blit(self.find,(50,400))
                self.screen.blit(self.level.winnerimage,(350,420))
                pygame.display.update()        
                self.level.timer.clock.tick()       
                #self.level.sound.play()
            if self.state=="victory":
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        pygame.quit()   
                        return    
                    elif event.type == KEYDOWN:
                        self.state="menu" 
                self.currentlevel=0       
                self.level.timer.clock.tick() 
                self.screen.blit(self.start_image,(0,0))
                self.screen.blit(self.captain,(0,350)) 
                self.screen.blit(self.key_menu,(50,400))
                pygame.display.update() 
                self.hoho.play()           
            if self.state=="menu":
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        pygame.quit()   
                        return
                    elif event.type == MOUSEBUTTONDOWN:
                        m_x,m_y=pygame.mouse.get_pos()
                        for choice in self.choice.buttons.sprites():
                            if choice.rect.collidepoint(m_x,m_y):
                                self.state=choice.return_text
                                if self.state=="next level":
                                    self.levellist=[]
                                    for level in self.copy:
                                            self.levellist.append(things.level(*level))
                                    self.currentlevel=0
                                    self.level=self.levellist[self.currentlevel]     
                                    self.level.timer.secondsleft=self.level.timer.startseconds+self.level.timer.seconds
                                    self.level.timer.minutesleft=self.level.timer.startminutes+self.level.timer.minutes                             
                    self.screen.blit(self.start_image,(0,0))
                    self.choice.buttons.draw(screen)
                    m_x,m_y=pygame.mouse.get_pos()
                    self.hook_rect=self.hook.get_rect(center=(m_x,m_y))
                    self.screen.blit(self.hook,self.hook_rect)
                    pygame.display.update()  
                    self.level.timer.clock.tick()      
            if self.state=="start":
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        pygame.quit()   
                        return
                    elif event.type == KEYDOWN:
                        self.state="menu"
                        self.level.timer.clock.tick()  
                    self.screen.blit(self.start_image,(0,0))
                    self.screen.blit(self.key_menu,(50,470))
                    pygame.display.update() 
            #print self.state,self.currentlevel,self.levellist[0].y_angle==self.levellist[1].y_angle                                                                       